	/**
 * This class provides an abstraction of the in game window and the
 * other classes. At some point it will automatically find the edge of
 * your game window and all possibly differently located objects like
 * grass/slate/clay, timers, etc. But for the moment you should set
 * the xOffset and yOffset to the number of pixels your ATITD window
 * is from the upper left hand side of the screen.
 * 
 * Most of this class was written by McArine, small parts were
 * modified by EldradUlthran.
 * 
 * @McArine
 * @23/02-2008
 */
import java.awt.Robot;
import java.awt.MouseInfo;
import java.awt.Color;
import java.awt.AWTException;

public class Functions
{
    //Location of your topleft corner, where you've stacked the windows, in your system coordinates.
    private static int xOffset = 0;
    private static int yOffset = 45;
	
	//Location of T3 timer. Obsolete due to new T4 method of 'red-ing' the stats.
    private static int xTimerLocation = 1276;
    private static int yTimerLocation = 136;
    
    private int Width;		//Width of window
    private int Height;		//Height of window
    private int NumberOfWindows;
    private int NumberOfRows;
    private Robot robot;
    
	//Unknown
    private int xSetup = 50;
    private int ySetup = 50;

    //Is called with the following attributes: Width of window, Height of window, number of windows, and number of rows you want on the screen.
    //The robot you're using is also required.
    //Can also be initialized with just the robot.
    public Functions(int InputWidth, int InputHeight, int InputNOW, int InputNOR)
    {
        Width = InputWidth;
        Height = InputHeight;
        NumberOfWindows = InputNOW;
        NumberOfRows = InputNOR;
        try {
            robot = new Robot();
        }
        catch (AWTException awte) {
            System.out.println("The Robot was not initialized "+awte + "\n");
        }
    }
    
    public Functions(){
        Width = 0;
        Height = 0;
        NumberOfWindows = 1;
        NumberOfRows = 1;
	try {
            robot = new Robot();
        }
        catch (AWTException awte) {
            System.out.println("The Robot was not initialized "+awte + "\n");
        }
    }

    public void SetupWindows() {
        int xMouse=MouseInfo.getPointerInfo().getLocation().x;
        int yMouse=MouseInfo.getPointerInfo().getLocation().y;
        for (int j = (NumberOfWindows - 1); j >= 0; j--) {
            robot.mouseMove(xSetup, ySetup);
            robot.delay(150);
            robot.mousePress(16);
            robot.delay(200);
            robot.mouseMove((xSetup + (j % NumberOfRows) * Width), (ySetup + (j / NumberOfRows) * Height));
            robot.delay(150);
            robot.mouseRelease(16);
            robot.delay(200);
        }
        robot.mouseMove(xMouse,yMouse);
	return;
    }
    
    //PressButton is either called with exact coordinates, or with button coordinates on the first window, 
    //and then with the window number you want the button pressed on.
    //Window numbers go from left to right, top to button. 6 windows, 3 rows:
    //1 2 3
    //4 5 6
    public void PressButton(int Xcoord, int Ycoord) {
        int xMouse=MouseInfo.getPointerInfo().getLocation().x;
        int yMouse=MouseInfo.getPointerInfo().getLocation().y;
        robot.mouseMove(Xcoord + xOffset, Ycoord + yOffset);
        robot.mousePress(16);
        robot.mouseRelease(16);
        robot.mouseMove(xMouse,yMouse);
    }
    
    public void PressButton(int Xcoord, int Ycoord, int WindowNumber) {
        PressButton((Xcoord + (Width * (WindowNumber % NumberOfRows))), (Ycoord + (Height * (WindowNumber / NumberOfRows))));
    }
    
    public void delay(int d){
	robot.delay(d);
    }
	
	public Color getPixelColor(int Xcoord, int Ycoord) {
		return robot.getPixelColor(Xcoord + xOffset, Ycoord + yOffset);
    }
	
	public Color getPixelColor(int Xcoord, int Ycoord, int WindowNumber) {
		return getPixelColor((Xcoord + (Width * (WindowNumber % NumberOfRows))), (Ycoord + (Height * (WindowNumber / NumberOfRows))));
    }

    public static int getYOffset() {
        return yOffset;
    }
    
    public static int getXTimer() {
        return xTimerLocation;
    }
    
    public static int getYTimer() {
        return yTimerLocation;
    }
}
